%define opix rdi
%define omv  rsi
%define bpix rdx
%define bmv  rcx
%define bcost eax
%define mask 0xffffc0c0
%define const_mv 0x01234567
%define const_pix 0x89abcdef

section .text align=16
align 16
global op_mv
op_mv:
    lea   r8,    [omv + const_mv]
    test  r8,    mask
    jne .end
    movzx r10d,  word [opix + const_pix]
    cmp   bcost, r10d
    jle .end
    lea   bpix,  [opix + const_pix]
    mov   bcost, r10d
    mov   bmv,   r8
.end:

align 16
global op_reset
op_reset:
    mov   opix,  bpix
    mov   omv,   bmv
.end:

align 16
global op_qreset
op_qreset:
    cmp   omv,   bmv
    mov   opix,  bpix
    mov   omv,   bmv
    jne .end
    ret
.end:

align 16
global op_setup
op_setup:
    mov   bpix,  opix
    mov   bmv,   omv
    movzx bcost, word [opix]
.end:

section .rodata align=16
%macro OP_SIZE 1
    global op_%1_size
    op_%1_size: dd op_%1.end - op_%1
%endmacro
OP_SIZE mv
OP_SIZE reset
OP_SIZE qreset
OP_SIZE setup
